﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows;

using Dicom;
using Dicom.Log;
using Dicom.Network;
using Dicom.Imaging;
using Dicom.Imaging.Codec;
using Dicom.IO.Buffer;

namespace Query_Retrieve_Tool
{
    public class GetPat
    {  
        public void GetPatient(string remotehost, Int16 port, string callingAET, string calledAET, string PatientID, string InstanaceUID, string SeriesInsUid)
        {
            MessageBox.Show(remotehost + " " + port.ToString() + " " + callingAET + " " + calledAET + " " + PatientID + " " + InstanaceUID + " " +  SeriesInsUid);

            DicomCFindRequest fr = DicomCFindRequest.CreatePatientQuery(PatientID);
            MessageBox.Show(callingAET + " " + InstanaceUID);
            DicomCMoveRequest mr = new DicomCMoveRequest(callingAET, InstanaceUID); //, SeriesInsUid);
            mr.OnResponseReceived = MoveFinished;

            var client = new DicomClient();
            client.NegotiateAsyncOps(2, 0);
            client.AddRequest(fr);
            client.AddRequest(mr);
            //client.BeginSend(remotehost, port, false, callingAET, calledAET, Done, client);
            client.Send(remotehost, port, false, callingAET, calledAET);
        }

        public void MoveFinished(DicomCMoveRequest request, DicomCMoveResponse response)
        {
            
            //MessageBox.Show("MoveFinished " + response.Remaining.ToString());
            //.... No code yet but inside response only a command dataset with 9 items, unsigned ints.. no images anywhere
        }

        public void Done(IAsyncResult result)
        {
            //MessageBox.Show("Done " + result.ToString());
            //...Blank, just made this to get BeginSend to work? Something goes here???
        }
    }
}
